#include "propeller.h"
#include "sys\thread.h"

#define A0 220
#define B0 247
#define C0 262
#define D0 294
#define E0 330
#define F0 349
#define G0 392

#define A1 (A0<<1)
#define B1 (B0<<1)
#define C1 (C0<<1)
#define D1 (D0<<1)
#define E1 (E0<<1)
#define F1 (F0<<1)
#define G1 (G0<<1)

#define A2 (A0<<2)
#define B2 (B0<<2)
#define C2 (C0<<2)
#define D2 (D0<<2)
#define E2 (E0<<2)
#define F2 (F0<<2)
#define G2 (G0<<2)

#define A3 (A0<<3)
#define B3 (B0<<3)
#define C3 (C0<<3)
#define D3 (D0<<3)
#define E3 (E0<<3)
#define F3 (F0<<3)
#define G3 (G0<<3)

#define CTRMODE (1<<28)+(1<<3)+(1<<1)
#define ON  (DIRA |= 1 << 10)
#define OFF (DIRA &= ~(1 << 10))

#define CTRMODE1 (1<<28)+11
#define ON1  (DIRA |= 1 << 11)
#define OFF1 (DIRA &= ~(1 << 11))

#define p1_8 (waitcnt((CLKFREQ>>4)+CNT))
#define p1_4 (waitcnt((CLKFREQ>>2)+CNT))
#define p1_2 (waitcnt((CLKFREQ>>1)+CNT))
#define p1_1 (waitcnt((CLKFREQ)+CNT))

#define play(a) (FRQA = (a) * 53)

#define STACKSIZE 20

static int cog_stack[STACKSIZE];
void jb1 ();
void jb2 ();

void main ()
{
	_start_cog_thread(cog_stack + STACKSIZE, jb1, NULL, NULL);
	p1_8;
	_start_cog_thread(cog_stack + 2 * STACKSIZE, jb2, NULL, NULL);

	while(1);
}

void jb1 ()
{
	int i = 0;
	CTRA = CTRMODE;
	while (i<2)
	{
		play(E3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_2;
		
		play(E3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_2;
		
		play(E3);ON;p1_8;OFF;p1_4;
		play(G3);ON;p1_8;OFF;p1_4;
		play(C3);ON;p1_8;OFF;p1_4;
		play(D3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_2;
		
		play(F3);ON;p1_8;OFF;p1_4;
		play(F3);ON;p1_8;OFF;p1_4;
		play(F3);ON;p1_8;OFF;p1_4;
		
		play(F3);ON;p1_8;OFF;p1_4;
		play(F3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_4;
		
		play(E3);ON;p1_8;OFF;p1_4;
		play(E3);ON;p1_8;OFF;p1_4;
		
		play(E3);ON;p1_8;OFF;p1_4;
		play(D3);ON;p1_8;OFF;p1_4;
		play(D3);ON;p1_8;OFF;p1_4;
		
		play(E3);ON;p1_8;OFF;p1_4;
		
		
		if (i == 0)
		{ 
			play(D3);ON;p1_8;OFF;p1_2;
			play(G3);ON;p1_8;OFF;p1_2;
		}
		else
		{
		play(D3);ON;p1_8;OFF;
		}
		i++;
		
	}
}


void jb2 ()
{
	int i = 0;
	CTRA = CTRMODE1;
	while (i<2)
	{
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_2;
		
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_2;
		
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(G2);ON1;p1_8;OFF1;p1_4;
		play(C2);ON1;p1_8;OFF1;p1_4;
		play(D2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_2;
		
		play(F2);ON1;p1_8;OFF1;p1_4;
		play(F2);ON1;p1_8;OFF1;p1_4;
		play(F2);ON1;p1_8;OFF1;p1_4;
		
		play(F2);ON1;p1_8;OFF1;p1_4;
		play(F2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_4;
		
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(E2);ON1;p1_8;OFF1;p1_4;
		
		play(E2);ON1;p1_8;OFF1;p1_4;
		play(D2);ON1;p1_8;OFF1;p1_4;
		play(D2);ON1;p1_8;OFF1;p1_4;
		
		play(E2);ON1;p1_8;OFF1;p1_4;
		
		
		if (i == 0)
		{ 
			play(D2);ON1;p1_8;OFF1;p1_2;
			play(G2);ON1;p1_8;OFF1;p1_2;
		}
		else
		{
		play(D2);ON1;p1_8;OFF1;
		}
		i++;
		
	}
}


